AIS_Shape DisplayMode

Hi all,

Im extremely new to OCCT3D, been basically checking some of the demos and i was wondering how to change the display mode of my shapes to a very specific visualization mode:

All Faces have to be shown in the color of the face (or body if no face color is defined)
All Edges have to be shown in black
All Wires have to be shown in the color of the wire

Is there a way to do that?

We are a spanish CAD/CAM company and we are exploring the possibility of changing our kernel to OCCT3D

Thank you very much!

Dmitrii Pasukhin's picture

Hello.

AIS interface of OCCT is flexible and offers you full control on any attributes.

There are 2 possible solution, write you own drawing or override attributes of already existed shapes. I will share some small samples, but correct samples require the infromation about your implementation.

Additionally, OCCT offers technical support (guiding you with OCCT usage), custom development (helping to create or modify your application or only some parts), trainings (online or on-side trainings with OCCT experts) and e-learnings.

The sample (it is just peaces of different classes, but just samples with overriding material of solids or edges):

void ImageDump::displayCutCurves(const BSONReader::CuttingCurves& aCuttingCurvesData,
                                                 Handle(AIS_InteractiveContext)                   theContext) const
{
  for (const auto& aCurveData : aCuttingCurvesData)
  {
    for (const auto& aTransformation : aCurveData.second)
    {
      Handle(AIS_Shape) aShapePrs = new AIS_Shape(aCurveData.first);
      aShapePrs->SetLocalTransformation(aTransformation);
      const Quantity_Color aCuttingLineColor = myVisParams.UseSpecifiedColor
                                             ? myVisParams.ColorCuttingLine
                                             : Quantity_NOC_BLUE;
      aShapePrs->SetColor(aCuttingLineColor);
      aShapePrs->Attributes()->SetLineAspect(new Prs3d_LineAspect(aCuttingLineColor, Aspect_TOL_SOLID, 5.0));
      theContext->Display(aShapePrs, AIS_Shaded, -1, Standard_False);
    }
  }
}


  Handle(XCAFDoc_ShapeTool) aShapeTool = XCAFDoc_DocumentTool::ShapeTool(myDoc->Main());
  TDF_LabelSequence aRootLabels;
  aShapeTool->GetFreeShapes(aRootLabels);
  for (TDF_LabelSequence::Iterator anIt(aRootLabels); anIt.More(); anIt.Next())
  {
    Handle(XCAFPrs_AISObject) aShapePrs = new XCAFPrs_AISObject(anIt.Value());
    if (myVisParams.HasFaceBoundaries)
    {
      aShapePrs->Attributes()->SetFaceBoundaryAspect(new Prs3d_LineAspect(myVisParams.BoundariesColor, Aspect_TOL_SOLID, 1.0));
    }
    aContext->Display(aShapePrs, AIS_Shaded, -1, Standard_False);
  }

void ImageDump::displaySolids(const BSONShapesData& theShapesData,
                                              Handle(AIS_InteractiveContext)        theContext)
{
  for (const auto& aShapeData : theShapesData.GetShapesData())
  {
    const TopoDS_Shape&                                 aCurrentShape   = aShapeData.first;
    const BSONShapesData::ShapeIndices& aCurrentIndices = aShapeData.second;

    const std::vector<gp_Trsf>* aTransformations = theShapesData.GetTransformations(aCurrentIndices);
    if (!aTransformations)
    {
      continue;
    }
  
    for (const auto& aTransformation : *aTransformations)
    {
      Handle(AIS_ColoredShape) aShapePrsTransformed = new AIS_ColoredShape(aCurrentShape);
      // Set color.
      if (const Quantity_Color* aColor = theShapesData.GetColor(aCurrentIndices))
      {
        aShapePrsTransformed->SetColor(*aColor);
      }
      // Set transformation.
      aShapePrsTransformed->SetLocalTransformation(aTransformation);
      // Set face boundary aspect.
      if (myVisParams.HasFaceBoundaries)
      {
        aShapePrsTransformed->Attributes()->SetFaceBoundaryAspect(new Prs3d_LineAspect(myVisParams.BoundariesColor,
                                                                                       Aspect_TOL_SOLID,
                                                                                       1.));
      }
      // Add to context.
      theContext->Display(aShapePrsTransformed, AIS_Shaded, -1, Standard_False);
    }
  }
}

Best regards, Dmitrii

Dario Dura Armadans's picture

Oh, great i see the idea!

Thanks for the tip, we most probably will be using tech support and elearnings soon, for now, its just a POC we are creating to see the viability of the project.

I was tinkering with the DefaultDrawer in the CSharp_D3D sample (wpf) OCCTProxyD3D.cpp OCCTProxyD3D::InitViewer() and added this:

    myAISContext()->DefaultDrawer()->SetFaceBoundaryDraw(Standard_True);
    myAISContext()->DefaultDrawer()->SetFaceBoundaryAspect(new Prs3d_LineAspect(Quantity_NOC_BLACK, Aspect_TOL_SOLID, 1.0));

And it worked like a charm!

Funnily i was so close to find the solution, but i was using the free and unfree boundaries instead, which did not have any effect (what are they?).

Will keep trying to figure out how to show the different face colors of step imported shapes (instead of forcing a single color for all) and tweaking the selection and hilight as per our needs.

Thanks so much for your help!
Best regards,
Dario

Attachments: 
gkv311 n's picture

Dario wrote:

Funnily i was so close to find the solution, but i was using the free and unfree boundaries instead, which did not have any effect (what are they?).

Prs3d_Drawer::FreeBoundaryAspect()/UnFreeBoundaryAspect()/WireAspect() aspects affect displaying edges in AIS_Wireframe mode (as well as UIsoAspect/VIsoAspect() for isolines). E.g. UnFree for internal boundaries (shared between faces), Free for external boundaries, Wire for edges that are not part of any boundary.

Dario Dura Armadans's picture

Great thanks for the info!

I guess then that LineAspect is for any curves/inear topology, isn't it?